from installclass import BaseInstallClass
from translate import N_
import os
import iutil
import pcmcia
from partitioning import *
from fsset import *

class InstallClass(BaseInstallClass):
    name = N_("Everything")
    pixmap = "everything.png"

    sortPriority = 5000
    arch = 'i386'

    def setSteps(self, dispatch):
	BaseInstallClass.setSteps(self, dispatch);
	dispatch.skipStep("authentication")
	dispatch.skipStep("package-selection")

    def setGroupSelection(self, comps):
	BaseInstallClass.__init__(self, comps)
	comps["Everything"].select()
	
    def setInstallData(self, id):
	BaseInstallClass.setInstallData(self, id)

        autorequests = [ ("/", None, 2048, None, 1, 1) ]

        bootreq = getAutopartitionBoot()
        if bootreq:
            autorequests.append(bootreq)

        (minswap, maxswap) = iutil.swapSuggestion()
        autorequests.append((None, "swap", minswap, maxswap, 1, 1))

        id.partitions.autoClearPartType = CLEARPART_TYPE_LINUX
        id.partitions.autoClearPartDrives = None
        id.partitions.autoPartitionRequests = autoCreatePartitionRequests(autorequests)

    def __init__(self, expert):
	BaseInstallClass.__init__(self, expert)
